]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- add %service -n
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 %__rm                   /bin/rm --interactive=never
12
13 # Build system path macros.
14 #
15 %__autoconf             autoconf %{?debug:-Wall}
16 %__automake             automake -a -c -f --foreign
17 %__autopoint            autopoint --force
18
19 %__gettextize { \
20         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
21                 gettextize --copy --force --no-changelog; \
22         else \
23                 gettextize --copy --force --no-changelog --intl; \
24         fi; \
25         if [ ! -f po/Makevars ]; then \
26                 cp -f po/Makevars{.template,}; \
27         fi; \
28 }
29
30 %__glib_gettextize      glib-gettextize --copy --force
31 %__gnome_doc_common     gnome-doc-common --copy
32 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
33 %__gtkdocize            gtkdocize --copy
34 %__intltoolize          intltoolize --copy --force
35 %__libtoolize           libtoolize --copy --force
36
37 #       Path to top of build area.
38 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
39
40 #       The number of cvs changelog entries kept when building package.
41 %_buildchangelogtruncate 20
42
43 %dependencytracking     %{nil}
44
45 #       Relations between package names that cause dependency loops
46 #       with legacy packages that cannot be fixed. Relations are
47 #       specified as
48 #               p>q
49 #       where package p has a Requires: on something that package q Provides:
50 #
51 # XXX   Note: that there cannot be any whitespace within the string "p>q",
52 #       and that both p and q are package names (i.e. no version/release).
53 %_dependency_whiteout   %{nil}
54
55 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
58
59 #-----------------------------------------------------------------
60 #
61 # (re)definition of %{rpm*flags} with %filterout_* support
62 # BuildRequires:        awk
63 # BuildRequires:        rpmbuild(macros) >= 1.315
64 #
65 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
66 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
67 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
68 # %rpmldflags   = %optldflags - %filterout_ld
69 #
70 # Regular expressions are supported, but to avoid some character be treated
71 # as regular expression it must be escaped twice.
72
73 %filter_out                                             \
74         for (i = 1; i in I; i++) {      A=0;    \
75                 for (f in F) {                          \
76                         if (I[i] ~ "^" F[f] "$") A=1;   \
77                 };                                                      \
78                 if (!A) printf(I[i] FS);        \
79         }
80
81 %rpmcflags %(awk 'BEGIN {
82         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
83         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
84         %{filter_out}
85 }')
86
87 %rpmcxxflags %(awk 'BEGIN {
88         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
90         %{filter_out}
91 }')
92
93 %rpmldflags %(awk 'BEGIN {
94         split("%{?optldflags}",I);
95         split("%{?filterout_ld}",F)
96         %{filter_out}
97 }')
98
99 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100 # but, don't use it, better use gcc as linker
101 %ld_rpmldflags %(awk 'BEGIN {
102         split("%{rpmldflags}",F);
103         for (f in F) {
104                 s = F[f];
105                 if (s ~ /^-Wl,/) {
106                         s = substr(s,5);
107                         gsub(/,/," ",s);
108                 };
109                 printf(s FS);
110         };
111 }')
112
113 #-----------------------------------------------------------------
114 %configure2_13 { \
115  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
118  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
119  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
120  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
121  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
122  %{?__cc:CC="%{__cc}" ; export CC ; } \
123  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
124  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
125         --host=%{_target_platform} \
126         --prefix=%{_prefix} \
127         --exec-prefix=%{_exec_prefix} \
128         --bindir=%{_bindir} \
129         --sbindir=%{_sbindir} \
130         --sysconfdir=%{_sysconfdir} \
131         --datadir=%{_datadir} \
132         --includedir=%{_includedir} \
133         --libdir=%{_libdir} \
134         --libexecdir=%{_libexecdir} \
135         --localstatedir=%{_localstatedir} \
136         --sharedstatedir=%{_sharedstatedir} \
137         --mandir=%{_mandir} \
138         --infodir=%{_infodir} \
139         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
140         %{dependencytracking} \
141 }
142
143 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144 %__cmake        /usr/bin/cmake
145 %cmake { \
146 CC="%{__cc}" \
147 CXX="%{__cxx}" \
148 CFLAGS="%{rpmcflags}" \
149 CXXFLAGS="%{rpmcxxflags}" \
150 %{__cmake} \
151 }
152
153 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
154 %__scons        /usr/bin/scons
155 %scons { \
156 %{__scons} \
157         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158         CFLAGS="${CFLAGS:-%rpmcflags}" \
159         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160         FFLAGS="${FFLAGS:-%rpmcflags}" \
161         CPPFLAGS="${CPPFLAGS:-}" \
162         %{?__cc:CC="%{__cc}"} \
163         %{?__cxx:CXX="%{__cxx}"} \
164         libsuffix=%{_lib} \
165         prefix=%{_prefix} \
166 }
167
168 # waf. see waf.spec
169 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
170 %__waf  /usr/bin/waf
171 %waf { \
172 CC="%{__cc}" \
173 CXX="%{__cxx}" \
174 CPP="%{__cpp}" \
175 CFLAGS="%{rpmcflags}" \
176 CXXFLAGS="%{rpmcxxflags}" \
177 %{__waf} \
178 }
179
180 #----------------------------------------------------------------
181 #%configure_cache 0
182 %configure_cache_file   %{buildroot}.configure.cache
183
184 %configure {./configure \
185         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186         CFLAGS="${CFLAGS:-%rpmcflags}" \
187         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
188         FFLAGS="${FFLAGS:-%rpmcflags}" \
189         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
190         CPPFLAGS="${CPPFLAGS:-}" \
191         %{?__cc:CC="%{__cc}"} \
192         %{?__cxx:CXX="%{__cxx}"} \
193         --host=%{_target_platform} \
194         --build=%{_target_platform} \
195         --prefix=%{_prefix} \
196         --exec-prefix=%{_exec_prefix} \
197         --bindir=%{_bindir} \
198         --sbindir=%{_sbindir} \
199         --sysconfdir=%{_sysconfdir} \
200         --datadir=%{_datadir} \
201         --includedir=%{_includedir} \
202         --libdir=%{_libdir} \
203         --libexecdir=%{_libexecdir} \
204         --localstatedir=%{_localstatedir} \
205         --sharedstatedir=%{_sharedstatedir} \
206         --mandir=%{_mandir} \
207         --infodir=%{_infodir} \
208         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
209         %{dependencytracking} \
210         %{?configure_cache:--cache-file=%{configure_cache_file}} \
211 }
212
213 # overload to insert debuginfo package
214 %prep \
215 %if 0%{?_enable_debug_packages}\
216 %{debug_package}\
217 %endif\
218 %%prep\
219 %{nil}
220
221 # Location of autoconf macros
222 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
223
224 # Location of omf files
225 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
226
227 # Location of pkgconfig files
228 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
229 # noarch pkgconfig files
230 %_npkgconfigdir /usr/share/pkgconfig
231
232 # Location of desktop files
233 %_desktopdir    /usr/share/applications
234 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
235
236 # Location of pixmaps for applnk/desktop files
237 %_pixmapsdir    /usr/share/pixmaps
238
239 # Location of themable icons for applnk/desktop files
240 %_iconsdir      /usr/share/icons
241
242 # Location of fonts directories
243 %_fontsdir      /usr/share/fonts
244
245 # Location of Gtk and associated libraries documentation
246 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
247
248 # Location of KDE documentation
249 %_kdedocdir     %{_defaultdocdir}/kde/HTML
250
251 # unsermake script
252 %__unsermake /usr/share/unsermake/unsermake
253
254 # Current date
255 %date           %(LC_ALL="C" date +"%a %b %d %Y")
256
257 # Example files, programs, scripts...
258 %_examplesdir   /usr/src/examples
259
260 # Alternative kernel type/version
261 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
262
263 # The directory holding Linux kernel sources
264 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
265
266 # If non-empty "debug" macro defined, add "dbg" suffix to release number
267 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
268
269 # Requires name = version-release
270 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
271
272 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
273 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
274 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
275 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
276 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
277 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
278
279 # XXX: why epoch 0 is stripped?
280 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
281 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
282
283 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
284
285 # kernel version-release handling
286 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
287         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
288         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
289         echo ${Z:-ERROR}; \\
290 )}%__kernel_ver
291
292 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
293 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
294 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
295 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
296
297 # sgml macros
298 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
299 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
300 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
301 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
302 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
303 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
304 %docbook_sgmlcat_fix() { for l in \
305 '' \
306 '  -- default decl --' \
307 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
308 '  -- hacks for opensp --' \
309 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
310 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
311 '' \
312 ; do echo $l; done >> %1 \
313 }
314
315 # vim - "
316
317 # minimum file size needed for compressed documents.
318 # just smaller files than this get larger when compressed.
319 # some stats:
320 # - 0 byte file compressed was 25 bytes .gz
321 # - 39 byte file was compressed as 57
322 # - with test/test.spec@man 158 byte file was compressed also 158
323 %_min_compress_bytes    159
324
325 #-----------------------------------------------------------------
326 # find and gzip all files in %{_mandir} and %{infodir}
327 #
328 # Requires: xargs, find
329 #
330 #%no_install_post_compress_docs 1
331 %__spec_install_post_compress_docs { \
332 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
333         for i in /usr/share/man /usr/X11R6/man; do \
334                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
335                         echo "Compress man pages: $i"; \
336                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
337                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
338                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
339                                 m=$(readlink $a); \
340                                 rm -f $a; \
341                                 echo .so ${m##*/} > $a; \
342                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
343                         done; \
344                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
345                 fi; \
346         done; \
347         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
348                 echo "Compress info pages: %{_infodir}"; \
349                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
350                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
351                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
352         fi; \
353 }; __spec_install_post_compress_docs } }
354
355 #-----------------------------------------------------------------
356 # Strip executable binaries and shared object files
357 #
358 # Requires: find, awk, strip, cut, xargs
359 #
360 # Special macros which affect this process:
361 #%no_install_post_strip 1               # disable stripping at all
362 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
363 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
364 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
365 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
366 #
367 %__spec_install_post_strip {%{!?debug: \
368 %{!?no_install_post_strip:__spec_install_post_strip() { \
369 if [ -d "$RPM_BUILD_ROOT" ]; then \
370         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
371                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
372                 if [ "$modulelist" ]; then \
373                         modulecount=$(echo "$modulelist" | wc -l); \
374                         printf "Stripping %d kernel modules..." $modulecount; \
375                         echo "$modulelist" | xargs -l512 chmod u+w; \
376                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
377                         echo "DONE"; \
378                 fi; \
379         fi; \
380         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
381         if [ -n "$filelist" ]; then \
382                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
383                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
384                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
385                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
386                 if [ -n "$elfexelist" ]; then \
387                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
388                         chmod u+w $elfexelist; \
389                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
390                         echo "DONE"; \
391                 fi; \
392                 if [ -n "$elfsharedlist" ]; then \
393                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
394                         chmod u+w $elfsharedlist; \
395                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
396                         echo "DONE"; \
397                 fi; \
398                 if [ -n "$archiveslist" ]; then \
399                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
400                         chmod u+w $archiveslist; \
401                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
402                         echo "DONE"; \
403                 fi; \
404         fi; \
405     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
406     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
407     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
408         if [ -n "$filelist_all" ]; then \
409                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
410                 chmod u+w $filelist_all; \
411                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
412                 echo "DONE"; \
413         fi; \
414         if [ -n "$filelist_unneeded" ]; then \
415                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
416                 chmod u+w $filelist_unneeded; \
417                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
418                 echo "DONE"; \
419         fi; \
420         if [ -n "$filelist_debug" ]; then \
421                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
422                 chmod u+w $filelist_debug; \
423                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
424                 echo "DONE"; \
425         fi; \
426 fi; }; __spec_install_post_strip } } }
427
428 #-----------------------------------------------------------------
429 # remove all RPATH from executable binaries and shared object files
430 #
431 # Requires: find, awk, cut, xargs, chrpath, uname
432 #
433 # Special macros which affect this process
434 #%no_install_post_chrpath       1       # disable chrpath at all
435 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
436 #
437 %__spec_install_post_chrpath {%{!?debug: \
438 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
439 if [ -d "$RPM_BUILD_ROOT" ]; then \
440         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
441         if [ -n "$files" ]; then \
442                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
443         fi; \
444         if [ -n "$objs" ]; then \
445                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
446                 echo "$objs" | \
447                 while read file; do \
448                         rpath= ; \
449                         chmod u+w "$file"; \
450                         for dir in `chrpath -l "$file" | \
451                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
452                                         case $dir in \
453                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
454                                                 echo "remove-rpath: $dir in $file"; \
455                                                 ;; \
456                                         * ) \
457                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
458                                                 else rpath="$rpath:$dir" ; fi ; \
459                                                 ;; \
460                                         esac ; \
461                         done ; \
462                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
463                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
464                 done; \
465         fi; \
466 fi; }; __spec_install_post_chrpath } } }
467
468 #-----------------------------------------------------------------
469 # Find and gzip all kernel modules
470 #
471 # Requires: find
472 #
473 #%no_install_post_compress_modules      1
474 %__spec_install_post_compress_modules { \
475 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
476         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
477                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
478                 if [ "$q" ]; then \
479                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
480                         echo "$q" | xargs -r %{__gzip} -9nf; \
481                         echo "DONE"; \
482                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
483                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
484                 fi; \
485         fi; \
486 }; __spec_install_post_compress_modules } }
487
488 # Remove common Perl files we don't package
489 %__spec_install_post_perl_clean {\
490 %{!?no_install_post_perl_clean: \
491 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
492 } }
493
494 #-----------------------------------------------------------------
495 # Update GConf2 schemas
496 #
497 # Requires: GConf2
498 #
499 %gconf_schema_install() \
500         umask 022; \
501         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
502 %{nil}
503
504 %gconf_schema_uninstall() \
505 if [ $1 = 0 ]; then \
506         umask 022; \
507         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
508 fi; \
509 %{nil}
510
511 #-----------------------------------------------------------------
512 # Update desktop MIME database
513 # requires: desktop-file-utils
514 %update_desktop_database() {{ \
515         umask 022; \
516         /usr/bin/update-desktop-database -q; \
517 }}%{nil}
518
519 %update_desktop_database_post %update_desktop_database
520
521 %update_desktop_database_postun() {{ \
522 if [ "$1" = "0" ]; then \
523         %update_desktop_database; \
524 fi; \
525 }}%{nil}
526
527 #-----------------------------------------------------------------
528 # Update shared MIME info database
529 # requires: shared-mime-info
530 #
531 %update_mime_database() {{ \
532         umask 022; \
533         /usr/bin/update-mime-database %{_datadir}/mime; \
534 }}%{nil}
535
536 #-----------------------------------------------------------------
537 # Update icon cache
538 # requires: gtk+
539 #
540 %update_icon_cache() {{ \
541         umask 022; \
542         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
543 }}%{nil}
544
545 #-----------------------------------------------------------------
546 # Update scrollkeeper database
547 # requires: scrollkeeper
548 #
549 %scrollkeeper_update_post() \
550         /usr/bin/scrollkeeper-update -q; \
551 %{nil}
552
553 %scrollkeeper_update_postun() \
554 if [ "$1" = "0" ]; then \
555         /usr/bin/scrollkeeper-update -q; \
556 fi; \
557 %{nil}
558
559 #-----------------------------------------------------------------
560 # post %install sequence:
561 # - autodeps exceptions
562 # - compress all man and info pages,
563 # - strip all ELF executables and ELF shared objects if not %debug.
564 # - compress kernel modules if any
565
566 ###################################################################
567 # Requires/Provides automation
568 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
569 #
570 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
571 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
572 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
573 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
574 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
575
576 #%_noautocompressdoc    %{nil}
577 #
578 %_missing_doc_files_terminate_build     1%{nil}
579 %_unpackaged_files_terminate_build      %{nil}
580 # (X)emacs support
581 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
582 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
583 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
584
585 %__php_provides %{nil}
586 %__php_requires %{nil}
587 %__perl_provides %{nil}
588 %__perl_requires %{nil}
589 %__mono_provides %{nil}
590 %__mono_requires %{nil}
591
592 # Perl specific macro definitions.
593 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
594 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
595 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
596 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
597 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
598 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
599
600 # Ruby
601 %__ruby                         /usr/bin/ruby
602 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
603 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
604 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
605 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
606 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
607 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
608 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
609 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
610 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
611 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
612
613 %php_pear_dir           /usr/share/pear
614 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
615 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
616 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
617
618 # extract php/zend api versions
619 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
620 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
621 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
622 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
623 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
624 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
625 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
626
627 # helper macro
628 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
629
630 # macros for public use
631 # for php extensions (php-pecl)
632 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
633 %{__php_api_requires zend_module_api} \
634 %{__php_api_requires -v %php_major_version debug php_debug} \
635 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
636
637 # for zend extensions
638 %requires_zend_extension %{__php_api_requires zend_module_api} \
639 %{__php_api_requires zend_extension_api} \
640 %{__php_api_requires -v %php_major_version debug php_debug} \
641 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
642
643 # for php pdo modules (php-pecl-PDO_*)
644 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
645
646 # for using PHP post scripts. for PHP >= 5.0
647 %php_webserver_restart \
648 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
649 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
650 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
651         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
652         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
653                 %service -q php-fcgi restart \
654         fi \
655 fi \
656 %{nil}
657
658 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
659 %php4_webserver_restart \
660 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
661 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
662 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
663         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
664         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
665                 %service -q php-fcgi restart \
666         fi \
667 fi \
668 %{nil}
669
670
671 # X.org helper macros
672 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
673 #
674 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
675 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
676 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
677 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
678 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
679
680 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
681 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
682 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
683 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
684 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
685 %{__xorg_abi_requires font xorg_xserver_font_abi}
686 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
687 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
688
689 # Python specific macro definitions.
690 # python main version
691 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
692
693 # directories
694 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
695 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
696 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
697 %py_incdir              /usr/include/python%{py_ver}
698 %py_sitedir             %{py_libdir}/site-packages
699 %py_sitescriptdir %{py_scriptdir}/site-packages
700 %py_dyndir              %{py_libdir}/lib-dynload
701
702 # pure python modules compilation
703 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
704
705 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
706
707 # Software written in Python language require Python with main version
708 %pyrequires_eq() Requires:      %1
709
710 # Hardlink binary identical .pyc and .pyo files
711 # (idea by glen <at> pld-linux <dot> org)
712 %__spec_install_post_py_hardlink {\
713 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
714 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
715         b="${a%.pyc}.pyo"; \
716         if cmp -s "$a" "$b"; then \
717                 ln -f "$a" "$b"; \
718         fi; \
719 done \
720 }; __spec_install_post_py_hardlink } }
721
722 # remove python sources, so that check-files won't complain
723 # (idea by glen <at> pld-linux <dot> org)
724 %py_postclean() \
725 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
726  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
727 done \
728 %{nil}
729
730 # depmod macro
731 %depmod() { \
732 umask 022; \
733 if [ -e /boot/System.map-%1 ]; then \
734         /sbin/depmod -a -F /boot/System.map-%1 %1; \
735 else \
736         if [ -e /boot/System.map ]; then \
737                 /sbin/depmod -a -F /boot/System.map %1; \
738         else \
739                 /sbin/depmod -a %1; \
740         fi \
741 fi; \
742 }
743
744 # XMMS specific macros
745 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
746 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
747 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
748 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
749 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
750 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
751 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
752 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
753 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
754 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
755
756 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
757
758 # user/group checking macros
759 #
760 # Usage:
761 #       %userremove myuser
762 #
763 %userremove     /usr/lib/rpm/user_group.sh user del
764 %groupremove    /usr/lib/rpm/user_group.sh group del
765 #
766 # Usage:
767 #       if %usertestrm myuser; then
768 #               /usr/sbin/userdel -r myuser
769 # Note:
770 #       use these macros only if you need to call userdel/groupdel with
771 #       a non-standard option or take an extra action; otherwise use the
772 #       %userremove/%groupremove macros
773 #
774 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
775 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
776 # user group membership management macros
777 #
778 # Usage:
779 #       %addusertogroup myuser agroup
780 #
781 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
782
783 # banner support (useful in {pre,post}{,un} and triggers)
784 #
785 # Usage:
786 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
787 # the banner text, the banner text
788 # the banner text, and following line
789 #EOF
790 # You can use any form of here-document, <<'EOF' <<-EOT will do.
791 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
792 #
793 # -a   - append to the banner
794 # -e   - send to stderr instead of stdout
795 # -n   - no show banner (overrides -t)
796 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
797 #
798 # Tests:
799 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
800 # rpm -E 'date | %banner -e banner' > m; sh -x m
801 #
802 %banner(aent:) ( \
803 RPM_SCRIPTVERBOSITY=5 \
804 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
805 if [ -x /usr/bin/banner.sh ]; then \
806         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
807 else \
808         CMD="cat%{-e: >&2}" \
809 fi \
810 eval $CMD %{?2:%2}%{?3: %3}) \
811 %{nil}
812
813 # useradd/groupadd macros
814 # Author: Elan Ruusamäe <glen@pld-linux.org>
815 #
816 # Usage:
817 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
818 #   [-g initial_group] [-G group[,...]] login
819 #
820 #  -u uid. REQUIRED
821 #  -g gid/group. REQUIRED
822 #  -s defaults to /bin/false
823 #  -d defaults to /usr/share/empty
824 #  -c No default
825 #  -r is accepted but ignored (it's always set)
826 #  -k skeleton dir. defaults to /usr/share/empty
827 # rpm specific flags
828 #  -P package name. defaults to %{name}
829 #
830 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
831 %{!-u:%{error:useradd: Required argument -u missing}} \
832 %{!-g:%{error:useradd: Required argument -g missing}} \
833 %{!?1:%{error:useradd: Required parameter login missing}} \
834 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
835         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
836                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
837                 exit 1 \
838         fi \
839 else \
840         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
841         /usr/sbin/useradd \\\
842                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
843                 -u %{-u*} \\\
844                 -r \\\
845                 -d %{-d*}%{!-d:/usr/share/empty} \\\
846                 -s %{-s*}%{!-s:/bin/false} \\\
847                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
848                 -g %{-g*} \\\
849                 %{-M} \\\
850                 %{-G:-G %{-G*}} \\\
851                 %{expand:%{%{#}}} 1>&2 || exit $? \
852         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
853 fi;
854
855 # Usage:
856 #   %groupadd [-P package] [-g gid] group
857 #
858 # -g gid. REQUIRED
859 #
860 # Sample:
861 #   %groupadd -P %{name}-base -g %{gid} %{name}
862
863 %groupadd(g:P:rfo)      \
864 %{!-g:%{error:groupadd: Required argument -g missing}} \
865 %{!?1:%{error:groupadd: Required parameter group missing}} \
866 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
867         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
868                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
869                 exit 1 \
870         fi \
871 else \
872         echo "Adding group %{1} GID=%{-g*}." \
873         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
874         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
875 fi;
876
877 # webapp macros
878 # Author: Elan Ruusamäe <glen@pld-linux.org>
879 #
880 # The config is installed/removed inside trigger, this means that you can any
881 # time install apache1/apache/lighttpd package and the configuration file is
882 # updated. if you don't need the config for various reason for specific
883 # webserver, just remove the symlink from config directory using webapp
884 # program. the trigger will not recreate the symlink on upgrades. In other
885 # words the config is linked to webserver config directory on first install of
886 # PACKAGE or WEBSERVER.
887 #
888 # Add package's webserver config to webserver webapps dir.
889 # Usage:
890 #   %webapp_register WEBSERVER WEBAPP
891 #
892 %webapp_register() \
893 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
894 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
895         /usr/sbin/webapp register %1 %2\
896 fi\
897 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
898 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
899         %{expand:%service -q %%1 reload}\
900 fi\
901 %{nil}
902
903 # Remove package's config from webserver webapps dir.
904 # Usage:
905 #   %webapp_register [-f] WEBSERVER WEBAPP
906 %webapp_unregister(f) \
907 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
908 # remove link if either of the packages are gone \
909 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
910         /usr/sbin/webapp unregister %1 %2\
911         %{expand:%service -q %%1 reload}\
912 fi \
913 %{nil}
914
915 # service macro.
916 # Author: Elan Ruusamäe <glen@pld-linux.org>
917 #
918 # calls usual service restart on package %post, but skips the restart if
919 # administrator has disabled automatic service restarts in either global
920 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
921 #
922 # Usage:
923 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
924 #
925 #  -q be silent when service isn't started (for scriplets restaring other package's services)
926 #  -n NOOP mode, do not actually restart service
927 #
928 # Requirements:
929 # BuildRequires:        rpmbuild(macros) >= 1.268
930 # Requires:     rc-scripts
931 # -n option:
932 # BuildRequires:        rpmbuild(macros) >= 1.450
933 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
934
935
936 # Java macros. based on jpackage macros.java
937 #
938 # Root directory where all Java VMs/SDK/JREs are installed.
939 %_jvmdir                %{_libdir}/jvm
940
941 # Root directory where all Java VMs/SDK/JREs expose their jars
942 %_jvmjardir             %{_libdir}/jvm-exports
943
944 # Root directory for all Java VM/SDK/JRE's private things.
945 %_jvmprivdir    %{_libdir}/jvm-private
946
947 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
948 %_jvmlibdir             %{_libdir}/jvm
949
950 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
951 %_jvmdatadir    %{_datadir}/jvm
952
953 # Root directory for all configurations parts of Java VM/SDK/JRE's
954 %_jvmsysconfdir %{_sysconfdir}/jvm
955
956 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
957 %_jvmcommonlibdir       %{_libdir}/jvm-common
958
959 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
960 %_jvmcommondatadir      %{_datadir}/jvm-common
961
962 # Root directory for all common configurations parts of Java VM/SDK/JRE's
963 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
964
965 # Directory where arch-specific (JNI) version-independent jars are installed.
966 %_jnidir                %{_libdir}/java
967
968 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
969
970 %ant                    JAVA_HOME=%{java_home} ant
971 %jar                    %{java_home}/bin/jar
972 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
973 %javac                  %{java_home}/bin/javac
974 %javadoc                %{java_home}/bin/javadoc
975
976 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
977
978 %jpackage_script() \
979 install -d $RPM_BUILD_ROOT%{_bindir}\
980 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
981 #!/bin/sh\
982 #\
983 # %{name} script\
984 # JPackage Project <http://www.jpackage.org/>\
985 \
986 # Source functions library\
987 . %{_javadir}-utils/java-functions\
988 \
989 # Source system prefs\
990 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
991     . %{_sysconfdir}/java/%{name}.conf\
992 fi\
993 \
994 # Source user prefs\
995 if [ -f $HOME/.%{name}rc ]; then\
996     . $HOME/.%{name}rc\
997 fi\
998 \
999 # Configuration\
1000 MAIN_CLASS=%1\
1001 BASE_FLAGS=%2\
1002 BASE_OPTIONS=%3\
1003 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1004 \
1005 # Set parameters\
1006 set_jvm\
1007 set_classpath $BASE_JARS\
1008 set_flags $BASE_FLAGS\
1009 set_options $BASE_OPTIONS\
1010 \
1011 # Let's start\
1012 run "$@"\
1013 EOF
1014
1015 # jpackage 1.7
1016 # Directory for maven depmaps
1017 #
1018 %_mavendepmapdir /etc/maven
1019 %_mavendepmapfragdir /etc/maven/fragments
1020
1021 #
1022 # add_to_depmap adds an entry to the depmap. The arguments are:
1023 #
1024 # %1 the original groupid
1025 # %2 the original artifact id
1026 # %3 the version
1027 # %4 the new groupid
1028 # %5 the new artifactid
1029 #
1030
1031 %add_to_maven_depmap() \
1032 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1033 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1034 <dependency>\
1035     <maven>\
1036         <groupId>%1</groupId>\
1037         <artifactId>%2</artifactId>\
1038         <version>%3</version>\
1039     </maven>\
1040     <jpp>\
1041         <groupId>%4</groupId>\
1042         <artifactId>%5</artifactId>\
1043         <version>%3</version>\
1044     </jpp>\
1045 </dependency>\
1046 \
1047 EOF\
1048 %{nil}
1049
1050 #==============================================================================
1051 #
1052 # update_maven_depmap updates the main maven depmap
1053 #
1054 %update_maven_depmap() \
1055 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1056 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1057 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1058 fi\
1059 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1060
1061
1062 # PEAR install macros
1063 # Author: Elan Ruusamäe <glen@pld-linux.org>
1064 #
1065 # Usage:
1066 #       %%pear_package_setup [-a #] [-n FMT]
1067 #
1068 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1069 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1070 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1071 #
1072 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1073 # destination hierarchy. you should copy the tree to buildroot after
1074 # patching/reorganizing with %%pear_package_install.
1075 #
1076 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1077 # line endings.
1078 #
1079 # the pear install process output is recorded to install.log, you should put it
1080 # to %%doc for later debug or just for information.
1081 #
1082 # additionally additional-packages.txt is produced if it was detected that the
1083 # package has optional dependencies. the file format is suitable of displaying
1084 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1085 # automatically added for this file.
1086
1087
1088 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1089 %__pear_install_log \
1090 tee install.log \
1091 # make post message of optional packages \
1092 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1093 if [ -s optional-packages.txt ]; then \
1094         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1095 else \
1096         rm -f optional-packages.txt \
1097 fi \
1098 %{nil}
1099
1100 # command invoking pear cli
1101 %__pear /usr/bin/pear
1102
1103 %pear_install(a:n:zD) \
1104 %__pear \\\
1105         -c pearrc \\\
1106         -d doc_dir=/docs \\\
1107         -d php_dir=%{php_pear_dir} \\\
1108         -d bin_dir=%{_bindir} \\\
1109         -d data_dir=%{php_pear_dir}/data \\\
1110         -d test_dir=%{php_pear_dir}/tests \\\
1111         install \\\
1112         --packagingroot=%{builddir} \\\
1113         --offline \\\
1114         --nodeps \\\
1115         %{-f:--force} \\\
1116         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1117 %{nil}
1118
1119 # The main macro.
1120 # using this macro will append optional-packages.txt to the nocompressdoc list
1121 # as it's displayed to user after package install. and adding additional gzip
1122 # dep is just waste ;)
1123 %pear_package_setup(a:n:zD) \
1124 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1125 %define builddir %{_builddir}/%{srcdir} \
1126 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1127 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1128 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1129 %pear_install \
1130 %{-z:cd ..} \
1131 cat %{-z:$_N/}.install.log | %__pear_install_log \
1132 \
1133 # undos sources \
1134 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1135 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1136 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1137 %{nil}
1138
1139 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1140 # Author: Elan Ruusamäe <glen@pld-linux.org>
1141 %pear_package_install() \
1142 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1143 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1144 # help the developer out a little: \
1145 if [ -f _noautoreq ]; then \
1146         echo "AutoReqdep detected:" \
1147         echo "_noautoreq $(cat _noautoreq)" \
1148 fi \
1149 %{nil}
1150
1151
1152 # Register OpenLDAP schema.
1153 # Author: Elan Ruusamäe <glen@pld-linux.org>
1154 #
1155 # Usage:
1156 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1157 #
1158 #  -d specify dependant schemas, separated by comma
1159 #
1160 %openldap_schema_register(d:) \
1161 for schema in %*; do \
1162         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1163                 %{__sed} -i -e " \
1164                         /^include.*local.schema/{ \
1165                                 iinclude\\t     $schema\
1166                         } \
1167                 " /etc/openldap/slapd.conf \
1168         fi \
1169 done \
1170 # enable dependant schemas \
1171 if [ "%{-d*}" ]; then \
1172         %{__sed} -i -e ' \
1173         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1174                 s/^#// \
1175         }' /etc/openldap/slapd.conf \
1176 fi \
1177 %{nil}
1178
1179 # Unregister OpenLDAP schema.
1180 # Author: Elan Ruusamäe <glen@pld-linux.org>
1181 #
1182 # Usage:
1183 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1184 #
1185 %openldap_schema_unregister() \
1186 for schema in %*; do \
1187         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1188                 %{__sed} -i -e " \
1189                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1190                 # for symmetry it would be nice if we disable enabled schemas in post, \
1191                 # but we really can not do that, it would break something else. \
1192                 " /etc/openldap/slapd.conf \
1193         fi \
1194 done \
1195 %{nil}
1196
1197 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1198
1199
1200 # Build modules for kernels 2.6
1201 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1202 #
1203 # Usage:
1204 #       %build_kernel_modules -m <modules> -C <directory>
1205 #
1206 #  remember that proper Makefile is still required
1207 # Options:
1208 #  -m <modules> (required) -- comma-separated list of modules to save,
1209 #               without .ko extension, may be placed in subdirectory
1210 #  -C <directory> -- change to <directory> before doing anything
1211 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1212 #  -c -- do not execute make clean
1213 #  <additional arguments> -- all additional arguments will be passed to
1214 #               make modules
1215 #
1216 # Additional patching supported via here document. Try:
1217 #       %build_kernel_modules -m module <<'EOF'
1218 #       your patch script here
1219 #       EOF
1220 # Don't use it unless patching depends on config options.
1221
1222 # Developer note: don't touch it unless you know how to handle '\'.
1223 # - \ in script expands to nothing
1224 # - \\\ in script expands to \
1225 # - \\\ inside definition expands to nothing
1226 # - \\\\\\\ inside definition expands to \
1227 # - in last line \ has to touch arguments so arguments passing
1228 #   in new lines (using \) will be supported
1229
1230 %build_kernel_modules(p:P:m:C:c)                                                                        \
1231 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1232                                                                                                                                         \
1233 %define Opts                                                                                                            \\\\\\\
1234 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1235         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1236         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1237         %else                                                                                                                   \\\
1238         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1239         %endif                                                                                                                  \\\
1240 %else                                                                                                                           \\\
1241         CC="%{kgcc}"                                                                                                    \\\
1242 %endif                                                                                                                          \
1243 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1244                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1245                                                                                                                                         \
1246 %{?-C:cd %{-C*}}                                                                                                        \
1247 compile() {                                                                                                                     \
1248         local L="<" PATCH_SH;                                                                                   \
1249         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1250         set -e -x                                                                                                               \
1251         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1252                                                                                                                                         \
1253 for cfg in ${cfgs:-dist}; do                                        \
1254         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1255                                                                                                                                         \
1256         rm -rf o                                                                                                                \
1257         install -d o/include/linux                                                                              \
1258         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1259         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1260         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1261                                                                                                                                         \
1262         set +x                                                                                                                  \
1263         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1264         set -x                                                                                                                  \
1265                                                                                                                                         \
1266         %if %{with dist_kernel}                                                                                 \
1267                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1268                         %{-p*} %{-P*}                                                                                   \\\
1269                         %{MakeOpts}                                                                                             \
1270         %else                                                                                                                   \
1271                 install -d o/include/config                                                                     \
1272                 touch o/include/config/MARKER                                                           \
1273                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1274         %endif                                                                                                                  \
1275                                                                                                                                         \
1276         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1277                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1278                 ${1+"$@"}                                                                                                       \\\
1279                 M=$PWD %{MakeOpts}}                                                                                     \
1280                                                                                                                                         \
1281         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1282                 ${1+"$@"}                                                                                                       \\\
1283                 M=$PWD %{MakeOpts}                                                                                      \
1284                                                                                                                                         \
1285         for MODULE in {%{-m*},}; do                                                                             \
1286                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1287         done                                                                                                                    \
1288 done                                                                                                                            \
1289 %{?-C:cd -}                                                                                                                     \
1290 }                                                                                                                                       \
1291 compile %{*}\
1292 %{nil}
1293
1294
1295 # Install kernel modules built by %build_kernel_modules
1296 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1297 #
1298 # Usage:
1299 #       %install_kernel_modules -m <modules> -d <directory>
1300 #
1301 # Options:
1302 #  -m <modules> (required) -- comma-separated list of modules to install,
1303 #               without .ko extension, may be placed in subdirectory
1304 #  -d <directory> (required) -- in what subdirectory modules should be
1305 #               installed (eg. misc, kernel/drivers/net)
1306 #  -s <suffix> -- suffix to use when installing modules, useful when module
1307 #               with same name exists in kernel already
1308 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1309 #               for defining aliases, only useful with -s
1310
1311 %install_kernel_modules(m:d:s:n:)                                                                       \
1312 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1313 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1314 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1315                                                                                                                                         \
1316 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1317 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1318                                                                                                                                         \
1319 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1320                                                                                                                                         \
1321 for MODULE in {%{-m*},}; do                                                                                     \
1322         [ -n "${MODULE}" ] || continue                                                                  \
1323         for cfg in ${cfgs:-dist}; do                                    \
1324                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1325                 MNAME=${MODULE##*/}                                                                                     \
1326                 install -D ${MODULE}-$cfg.ko                                                            \\\
1327                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1328                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1329                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1330                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1331         done                                                                                                                    \
1332 done                                                                                                                            \
1333 %{nil}
1334
1335 # patchset macros
1336 # Author: Elan Ruusamäe <glen@pld-linux.org>
1337 #
1338 # Usage:
1339 #   %patchset_source -f <seq(1) format> <start> [<end>]
1340 #   %patchset_patch <start> [<end>]
1341 #
1342 # If <end> is omited, it is assumed to be <start>.
1343 #
1344 # For example in preamble:
1345 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1346 # and in %prep:
1347 #  %patchset_patch 33 44
1348
1349 # generate SourceX urls from range START STOP
1350 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1351 # The sources start from 10000
1352 %patchset_source(f:b:) %(
1353         base=%{-b*}%{!-b*:10000};
1354         start=$(expr $base + %1);
1355         end=$(expr $base + %{?2}%{!?2:%{1}});
1356         # we need to call seq twice as it doesn't allow two formats
1357         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1358         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1359         paste %{tmpdir}/__ps{1,2};
1360         rm -f %{tmpdir}/__ps{1,2};
1361 ) \
1362 %{nil}
1363
1364 # apply sources from %patchset_source
1365 # -p specify -pX for %patch line
1366 # -b base offset: defaults to 10000
1367 %patchset_patch(f:p:b:) %(
1368         base=%{-b*}%{!-b*:10000};
1369         start=$(expr $base + %1);
1370         end=$(expr $base + %{?2}%{!?2:%{1}});
1371         echo ": patchset_patch %1%{?2: to %2}";
1372         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1373 ) \
1374 %{nil}
1375
1376 # browser plugins v2
1377 # Author: Elan Ruusamäe <glen@pld-linux.org>
1378 #
1379 # Usage:
1380 #       %browser_plugins_add_browser <name> -p <plugindir>
1381 #
1382 #  <name> (required) -- name of the browser. usually %{name}.
1383 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1384 #  -b -- default blacklists
1385 #  -a <arch> override arch
1386 #
1387 # Example:
1388 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1389
1390 %_browserpluginsconfdir         /etc/browser-plugins
1391 %_browserpluginsdir                     %{_libdir}/browser-plugins
1392 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1393
1394 %browser_plugins_add_browser(p:b:a:) \
1395         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1396         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1397         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1398         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1399         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1400         %{-b:cat >> $blacklist_file %{-b*}} \
1401 %{nil}
1402
1403 # Helper for LUA.
1404 # split string separated by space into quoted list
1405 #
1406 # Author: Elan Ruusamäe <glen@pld-linux.org>
1407 #
1408 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1409 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1410
1411 # adjust /etc/shells by adding and removing shells from there
1412 # Author: Elan Ruusamäe <glen@pld-linux.org>
1413 #
1414 # Usage:
1415 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1416 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1417 #
1418 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1419 #
1420 # Requirements:
1421 # BuildRequires:        rpmbuild(macros) >= 1.429
1422
1423 %add_etc_shells(p) %{-p:<lua>}\
1424 t = {}\
1425 f = io.open("/etc/shells", "r")\
1426 if f then\
1427         for l in f:lines() do t[l]=l; end\
1428         f:close()\
1429 end\
1430 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1431         if not t[s] then\
1432                 print("Adding "..s.." to /etc/shells")\
1433                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1434         end\
1435 end\
1436 %{nil}
1437
1438 %remove_etc_shells(p) %{-p:<lua>}\
1439 %{-p:if arg[2] == 0 then}\
1440         t = {}\
1441         f = io.open("/etc/shells", "r")\
1442         if f then\
1443                 for l in f:lines() do t[l]=l; end\
1444                 f:close()\
1445         end\
1446         for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1447                 print("Removing "..l.." from /etc/shells")\
1448                 t[l] = nil\
1449         end\
1450         s=""\
1451         for _, l in pairs(t) do\
1452                 s=s..l.."\\n"\
1453         end\
1454         io.open("/etc/shells", "w"):write(s)\
1455 %{-p:end} \
1456 %{nil}
1457
1458 # vim:ts=4 sw=4 noet syn=spec
This page took 0.276888 seconds and 4 git commands to generate.